#ifndef _MENUBOARD_H_
#define _MENUBOARD_H_

void menu_init();

typedef void (*FuncPtr)(void);
//function pointer
FuncPtr FPtr;

struct Menu_State{
	 uint8_t menuNo;//1-12
	 uint8_t subMenuNo;//1,2,3 
}MN;

// SELECT MODEL
const uint8_t model0[] PROGMEM="DEF\0";
const uint8_t model1[] PROGMEM="NO1\0";
const uint8_t model2[] PROGMEM="NO2\0";
const uint8_t model3[] PROGMEM="NO3\0";
const uint8_t model4[] PROGMEM="NO4\0";
const uint8_t model5[] PROGMEM="NO5\0";


const uint8_t *models[] = {model0,model1,model2,model3,model4,model5};

// SWA,SWB values
const uint8_t swx1[] PROGMEM="NULL\0";
const uint8_t swx2[] PROGMEM="D/R\0";
const uint8_t swx3[] PROGMEM="TR-OFF\0";
const uint8_t swx4[] PROGMEM="NORM\0";

// pointer SWA SWB string
const uint8_t *SWX[] ={swx1,swx2,swx3,swx4};


// MIX 1,2,2
const uint8_t mx1[] PROGMEM="SWA\0";
const uint8_t mx2[] PROGMEM="SWB\0";
const uint8_t mx3[] PROGMEM="ON\0";
const uint8_t mx4[] PROGMEM="OFF\0";

const uint8_t *MIXSW[] = {mx1,mx2,mx3,mx4};

const uint8_t mxch1[] PROGMEM="CH1\0";
const uint8_t mxch2[] PROGMEM="CH2\0";
const uint8_t mxch3[] PROGMEM="CH3\0";
const uint8_t mxch4[] PROGMEM="CH4\0";
const uint8_t mxch5[] PROGMEM="CH5\0";
const uint8_t mxch6[] PROGMEM="CH6\0";
const uint8_t mxch7[] PROGMEM="VRA\0";
const uint8_t mxch8[] PROGMEM="VRB\0";

const uint8_t *MIXCH[] ={mxch1,mxch2,mxch3,mxch4,mxch5,mxch6,mxch7,mxch8};

// 0 = NULL 1= Pitchadjust 
const uint8_t mxsv1[] PROGMEM="PitchAdj\0";

const uint8_t *MSV[] = {swx1,mxsv1};


// Model Type names
const uint8_t mt1[] PROGMEM="ACRO\0";
const uint8_t mt2[] PROGMEM="H-120\0";
const uint8_t mt3[] PROGMEM="H-90\0";
const uint8_t mt4[] PROGMEM="H-140\0";

const uint8_t *MT[] = {mt1,mt2,mt3,mt4};

// STICK Select Data
const uint8_t stk1[] PROGMEM="2 3\0";
const uint8_t stk2[] PROGMEM="3 2\0";
const uint8_t stk3[] PROGMEM="4+ +1\0";
const uint8_t stk4[] PROGMEM="1+ +4\0";

const uint8_t *STK0[] = {stk1,stk2}; //line 1
const uint8_t *STK1[] = {stk3,stk4}; //line 2

// Curve 0 = NOR 1 = ID
const uint8_t crv1[] PROGMEM="NOR\0";
const uint8_t crv2[] PROGMEM="ID \0";

const uint8_t *CRVE[] = {crv1,crv2}; 

/*
// Calibration
const uint8_t cali1[] PROGMEM="Start Adjust\0";
const uint8_t cali2[] PROGMEM="Stop Adjust \0";

const uint8_t *CALI[] = {cali1,cali2}; 
*/

// menu 0 INIT setup 
const uint8_t MN000[] PROGMEM="Welcome CT6B\0";

// menu intro
const uint8_t INTRO1[] PROGMEM="Wait, you must\0";
const uint8_t INTRO2[] PROGMEM="switch on TX\0";
const uint8_t MNOK[] PROGMEM="OK\0";
const uint8_t MNERR[] PROGMEM="ERR\0";
const uint8_t STOPPROGRAM[] PROGMEM="Program Halted!\0";


// menu 1 setup 
const uint8_t MN100[] PROGMEM="Menu SETUP\0";
const uint8_t MN101[] PROGMEM="Select MODEL:\0";
const uint8_t MN102[] PROGMEM="LOAD from MEM:\0";
const uint8_t MN103[] PROGMEM="SAVE to MEM:\0";
const uint8_t MN104[] PROGMEM="LOAD from TX:\0";
const uint8_t MN105[] PROGMEM="SAVE to TX:\0";


//menu 2  contains  6 submenus
const uint8_t MN200[] PROGMEM="<Reverse>\0";
const uint8_t MN201[] PROGMEM="CH1:\0";
const uint8_t MN202[] PROGMEM="CH2:\0";
const uint8_t MN203[] PROGMEM="CH3:\0";
const uint8_t MN204[] PROGMEM="CH4:\0";
const uint8_t MN205[] PROGMEM="CH5:\0";
const uint8_t MN206[] PROGMEM="CH6:\0";

//menu 3  D/R contains 6 submenus
const uint8_t MN300[] PROGMEM="D/Rt:0-100  R\0";
const uint8_t MN301[] PROGMEM="CH1  ON:\0";
const uint8_t MN302[] PROGMEM="CH1 OFF:\0";
const uint8_t MN303[] PROGMEM="CH2  ON:\0";
const uint8_t MN304[] PROGMEM="CH2 OFF:\0";
const uint8_t MN305[] PROGMEM="CH4  ON:\0";
const uint8_t MN306[] PROGMEM="CH4 OFF:\0";

// menu 4 end rate
const uint8_t MN400[] PROGMEM="EndRt:0-120 R\0";
const uint8_t MN401[] PROGMEM="CH1A:\0";
const uint8_t MN402[] PROGMEM="CH1B:\0";
const uint8_t MN403[] PROGMEM="CH2A:\0";
const uint8_t MN404[] PROGMEM="CH2B:\0";
const uint8_t MN405[] PROGMEM="CH3A:\0";
const uint8_t MN406[] PROGMEM="CH3B:\0";
const uint8_t MN407[] PROGMEM="CH4A:\0";
const uint8_t MN408[] PROGMEM="CH4B:\0";
const uint8_t MN409[] PROGMEM="CH5A:\0";
const uint8_t MN410[] PROGMEM="CH5B:\0";
const uint8_t MN411[] PROGMEM="CH6A:\0";
const uint8_t MN412[] PROGMEM="CH6B:\0";


// menu 5 subtrim
const uint8_t MN500[] PROGMEM="SubTr:+-120 R\0";
const uint8_t MN501[] PROGMEM="CH1:\0";
const uint8_t MN502[] PROGMEM="CH2:\0";
const uint8_t MN503[] PROGMEM="CH3:\0";
const uint8_t MN504[] PROGMEM="CH4:\0";
const uint8_t MN505[] PROGMEM="CH5:\0";
const uint8_t MN506[] PROGMEM="CH6:\0";

//menu 6 
const uint8_t MN600[] PROGMEM="<MIX1>\0";
const uint8_t MN601[] PROGMEM="MX1-Sourc:\0";
const uint8_t MN602[] PROGMEM="MX1-Dest:\0";
const uint8_t MN603[] PROGMEM="UP+-100 :\0";
const uint8_t MN604[] PROGMEM="DW+-100 :\0";
const uint8_t MN605[] PROGMEM="SWITCH:\0";

//menu 7
const uint8_t MN700[] PROGMEM="<MIX2>\0";
const uint8_t MN701[] PROGMEM="MX2-Sourc:\0";
const uint8_t MN702[] PROGMEM="MX2-Dest:\0";
const uint8_t MN703[] PROGMEM="UP+-100 :\0";
const uint8_t MN704[] PROGMEM="DW+-100 :\0";
const uint8_t MN705[] PROGMEM="SWITCH:\0";

//menu 8
const uint8_t MN800[] PROGMEM="<MIX3>\0";
const uint8_t MN801[] PROGMEM="MX3-Sourc:\0";
const uint8_t MN802[] PROGMEM="MX3-Dest:\0";
const uint8_t MN803[] PROGMEM="UP+-100 :\0";
const uint8_t MN804[] PROGMEM="DW+-100 :\0";
const uint8_t MN805[] PROGMEM="SWITCH:\0";

//menu 9
const uint8_t MN900[] PROGMEM="<FCN SWA>\0";
const uint8_t MN901[] PROGMEM="VALUE:\0";

// menu 10
const uint8_t MN1000[] PROGMEM="<FCN SWB>\0";
const uint8_t MN1001[] PROGMEM="VALUE:\0";

// menu 11
const uint8_t MN1100[] PROGMEM="<VR-A>\0";
const uint8_t MN1101[] PROGMEM="VALUE:\0";

// menu 12
const uint8_t MN1200[] PROGMEM="<VR-B>\0";
const uint8_t MN1201[] PROGMEM="VALUE:\0";

// menu 13
const uint8_t MN1300[] PROGMEM="Model Type\0";
const uint8_t MN1301[] PROGMEM="TYPE:\0";

// menu 14
const uint8_t MN1400[] PROGMEM="Stick Sel.\0";
const uint8_t MN1401[] PROGMEM="MODEL\0";

// menu 15
const uint8_t MN1500[] PROGMEM="LCD Display \0";
const uint8_t MN1501[] PROGMEM="Backlight \0";

// menu 16
const uint8_t MN1600[] PROGMEM="Calibration\0";
//const uint8_t MN1501[] PROGMEM="Start Adjust\0";
const uint8_t MN1601[] PROGMEM="Stop Adjust\0";
const uint8_t MN1602[] PROGMEM="Start Adjust\0";

// menu 17
const uint8_t MN1700[] PROGMEM="Thro Curve\0";
const uint8_t MN1701[] PROGMEM="MODEL:\0";
const uint8_t MN1702[] PROGMEM="EP0:\0";
const uint8_t MN1703[] PROGMEM="EP1:\0";
const uint8_t MN1704[] PROGMEM="EP2:\0";
const uint8_t MN1705[] PROGMEM="EP3:\0";
const uint8_t MN1706[] PROGMEM="EP4:\0";

// menu 18
const uint8_t MN1800[] PROGMEM="Pitch Curve\0";
const uint8_t MN1801[] PROGMEM="MODEL:\0";
const uint8_t MN1802[] PROGMEM="EP0:\0";
const uint8_t MN1803[] PROGMEM="EP1:\0";
const uint8_t MN1804[] PROGMEM="EP2:\0";
const uint8_t MN1805[] PROGMEM="EP3:\0";
const uint8_t MN1806[] PROGMEM="EP4:\0";

// menu 19
const uint8_t MN1900[] PROGMEM="Swash Afr\0";
const uint8_t MN1901[] PROGMEM="CH1:\0";
const uint8_t MN1902[] PROGMEM="CH2:\0";
const uint8_t MN1903[] PROGMEM="CH6:\0";


// pointer MENU string
const uint8_t *MENU[] ={
MN100,MN200,MN300,MN400,MN500,MN600,MN700,MN800,
MN900,MN1000,MN1100,MN1200,MN1300,MN1400,MN1500,
MN1600,MN1700,MN1800,MN1900
};

// pointer SUBMENU
const uint8_t *SUBMENU[] ={
MN101, MN102, MN103,MN104,MN105, 			// 5 submenus of menu 1
MN201, MN202, MN203,MN204,MN205,MN206, 		// 6 submenus of menu 2
MN301, MN302, MN303,MN304,MN305,MN306, 		// 6 submenus of menu 3
MN401, MN402, MN403,MN404,MN405,MN406, 	
MN407, MN408, MN409,MN410,MN411,MN412, 		//12 submenus of menu 4
MN501, MN502, MN503,MN504,MN505,MN506, 		// 6 submenus of menu 5
MN601, MN602, MN603,MN604,MN605, 			// 5 submenus of menu 6
MN701, MN702, MN703,MN704,MN705, 			// 5 submenus of menu 7
MN801, MN802, MN803,MN804,MN805, 			// 5 submenus of menu 8
MN901, 					               		// 1 submenu  of menu 9
MN1001, 									// 1 submenu  of menu 10
MN1101,										// 1 submenu  of menu 11
MN1201,										// 1 submenu  of menu 12
MN1301,										// 1 submenu  of menu 13
MN1401,										// 1 submenu  of menu 14
MN1501,										// 1 submenu  of menu 15
MN1601,MN1602,						        // 2 submenus of menu 16
MN1701,MN1702,MN1703,MN1704,MN1705,MN1706,	// 6 submenus of menu 17
MN1801,MN1802,MN1803,MN1804,MN1805,MN1806,	// 6 submenus of menu 18
MN1901,MN1902,MN1903                        // 3 submenus of menu 19

};

void menu_init()
{
  
	MN.menuNo = 1;
	MN.subMenuNo =1;
	lcd_clrscr();

}



#endif
